/* BookmarkRow.c generated by valac 0.56.17, the Vala compiler
 * generated from BookmarkRow.vala, do not modify */

/* BookmarkRow.vala
 *
 * Copyright 2020 elementary LLC. <https://elementary.io>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * Authors: Jeremy Wootten <jeremy@elementaryos.org>
 */

#include <gtk/gtk.h>
#include "pantheon-files-core.h"
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <cairo-gobject.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SIDEBAR_TYPE_BOOKMARK_ROW (sidebar_bookmark_row_get_type ())
#define SIDEBAR_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow))
#define SIDEBAR_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))
#define SIDEBAR_IS_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_IS_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_BOOKMARK_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))

typedef struct _SidebarBookmarkRow SidebarBookmarkRow;
typedef struct _SidebarBookmarkRowClass SidebarBookmarkRowClass;
typedef struct _SidebarBookmarkRowPrivate SidebarBookmarkRowPrivate;
enum  {
	SIDEBAR_BOOKMARK_ROW_0_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_ID_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_URI_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_NUM_PROPERTIES
};
static GParamSpec* sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _marlin_file_operations_common_job_unref0(var) ((var == NULL) ? NULL : (var = (marlin_file_operations_common_job_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))

struct _SidebarBookmarkRow {
	GtkListBoxRow parent_instance;
	SidebarBookmarkRowPrivate * priv;
	GtkGrid* content_grid;
	GtkGrid* icon_label_grid;
	GtkStack* label_stack;
	GtkEntry* editable;
	GtkLabel* label;
	GtkRevealer* drop_revealer;
};

struct _SidebarBookmarkRowClass {
	GtkListBoxRowClass parent_class;
	gboolean (*on_key_press_event) (SidebarBookmarkRow* self, guint keyval, guint keycode, GdkModifierType state);
	void (*button_release_event) (SidebarBookmarkRow* self, gint n_press, gdouble x, gdouble y);
	void (*popup_context_menu) (SidebarBookmarkRow* self);
};

struct _SidebarBookmarkRowPrivate {
	gboolean valid;
	GtkImage* icon;
	FilesFile* target_file;
	GList* drop_file_list;
	gchar* drop_text;
	gboolean drop_occurred;
	GdkDragAction* current_suggested_action;
	GtkEventControllerKey* key_controller;
	GtkGestureMultiPress* button_controller;
	gchar* _custom_name;
	SidebarSidebarListInterface* _list;
	guint32 _id;
	gchar* _uri;
	GIcon* _gicon;
	gboolean _pinned;
	gboolean _permanent;
	gboolean _can_insert_before;
	gboolean _can_insert_after;
	GMenuModel* _menu_model;
	GActionGroup* _action_group;
	gchar* _action_group_namespace;
};

static gint SidebarBookmarkRow_private_offset;
static gpointer sidebar_bookmark_row_parent_class = NULL;
static GtkTargetEntry* sidebar_bookmark_row_source_targets;
static gint sidebar_bookmark_row_source_targets_length1;
static GtkTargetEntry* sidebar_bookmark_row_source_targets = NULL;
static gint sidebar_bookmark_row_source_targets_length1 = 0;
static gint _sidebar_bookmark_row_source_targets_size_ = 0;
static GtkTargetEntry* sidebar_bookmark_row_dest_targets;
static gint sidebar_bookmark_row_dest_targets_length1;
static GtkTargetEntry* sidebar_bookmark_row_dest_targets = NULL;
static gint sidebar_bookmark_row_dest_targets_length1 = 0;
static gint _sidebar_bookmark_row_dest_targets_size_ = 0;
static GdkAtom sidebar_bookmark_row_text_data_atom;
static GdkAtom sidebar_bookmark_row_text_data_atom = 0U;
static SidebarSidebarItemInterfaceIface * sidebar_bookmark_row_sidebar_sidebar_item_interface_parent_iface = NULL;

VALA_EXTERN GType sidebar_bookmark_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SidebarBookmarkRow, g_object_unref)
VALA_EXTERN gboolean sidebar_bookmark_row_on_key_press_event (SidebarBookmarkRow* self,
                                                  guint keyval,
                                                  guint keycode,
                                                  GdkModifierType state);
VALA_EXTERN void sidebar_bookmark_row_button_release_event (SidebarBookmarkRow* self,
                                                gint n_press,
                                                gdouble x,
                                                gdouble y);
VALA_EXTERN void sidebar_bookmark_row_popup_context_menu (SidebarBookmarkRow* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GdkDragAction* _gdk_drag_action_dup (GdkDragAction* self);
VALA_EXTERN SidebarBookmarkRow* sidebar_bookmark_row_new (const gchar* _custom_name,
                                              const gchar* uri,
                                              GIcon* gicon,
                                              SidebarSidebarListInterface* list,
                                              gboolean pinned,
                                              gboolean permanent);
VALA_EXTERN SidebarBookmarkRow* sidebar_bookmark_row_construct (GType object_type,
                                                    const gchar* _custom_name,
                                                    const gchar* uri,
                                                    GIcon* gicon,
                                                    SidebarSidebarListInterface* list,
                                                    gboolean pinned,
                                                    gboolean permanent);
static void sidebar_bookmark_row_real_update_plugin_data (SidebarSidebarItemInterface* base,
                                                   FilesSidebarPluginItem* item);
static void sidebar_bookmark_row_rename (SidebarBookmarkRow* self);
VALA_EXTERN const gchar* sidebar_bookmark_row_get_display_name (SidebarBookmarkRow* self);
VALA_EXTERN void sidebar_bookmark_row_cancel_rename (SidebarBookmarkRow* self);
static void sidebar_bookmark_row_real_destroy_bookmark (SidebarSidebarItemInterface* base);
static gboolean sidebar_bookmark_row_real_on_key_press_event (SidebarBookmarkRow* self,
                                                       guint keyval,
                                                       guint keycode,
                                                       GdkModifierType state);
static void sidebar_bookmark_row_real_button_release_event (SidebarBookmarkRow* self,
                                                     gint n_press,
                                                     gdouble x,
                                                     gdouble y);
static void sidebar_bookmark_row_real_popup_context_menu (SidebarBookmarkRow* self);
static void __lambda148_ (SidebarBookmarkRow* self);
static void ___lambda148__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                         gpointer self);
static void __lambda149_ (SidebarBookmarkRow* self);
static void ___lambda149__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                         gpointer self);
static void __lambda150_ (SidebarBookmarkRow* self);
static void ___lambda150__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                         gpointer self);
static void sidebar_bookmark_row_real_add_extra_menu_items (SidebarSidebarItemInterface* base,
                                                     PopupMenuBuilder* menu_builder);
static void ___lambda151_ (SidebarBookmarkRow* self);
static void ____lambda151__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                          gpointer self);
static void ___lambda152_ (SidebarBookmarkRow* self);
static void ____lambda152__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                          gpointer self);
static void ___lambda153_ (SidebarBookmarkRow* self);
static void ____lambda153__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                          gpointer self);
static void sidebar_bookmark_row_set_up_drag (SidebarBookmarkRow* self);
static void __lambda154_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx);
static void ___lambda154__gtk_widget_drag_begin (GtkWidget* _sender,
                                          GdkDragContext* context,
                                          gpointer self);
static void __lambda155_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx,
                   GtkSelectionData* sel_data,
                   guint info,
                   guint time);
static guint8* _vala_array_dup3 (guint8* self,
                          gssize length);
static void ___lambda155__gtk_widget_drag_data_get (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_,
                                             gpointer self);
static void __lambda156_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx);
static void sidebar_bookmark_row_reset_drag_drop (SidebarBookmarkRow* self);
static void ___lambda156__gtk_widget_drag_end (GtkWidget* _sender,
                                        GdkDragContext* context,
                                        gpointer self);
static void sidebar_bookmark_row_set_up_drop (SidebarBookmarkRow* self);
static void __lambda157_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx,
                   gint x,
                   gint y,
                   GtkSelectionData* sel_data,
                   guint info,
                   guint time);
static gboolean sidebar_bookmark_row_process_dropped_row (SidebarBookmarkRow* self,
                                                   const gchar* drop_text,
                                                   gboolean dropped_between);
static gboolean sidebar_bookmark_row_process_dropped_uris (SidebarBookmarkRow* self,
                                                    GdkDragAction selected_action,
                                                    GdkDragAction possible_actions,
                                                    GList* drop_file_list,
                                                    gboolean dropped_between);
static void ___lambda157__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint time_,
                                                  gpointer self);
static gboolean __lambda158_ (SidebarBookmarkRow* self,
                       GdkDragContext* ctx,
                       gint x,
                       gint y,
                       guint time);
VALA_EXTERN gboolean sidebar_bookmark_row_reveal_drop_target (SidebarBookmarkRow* self,
                                                  gboolean reveal);
static gboolean _gdk_drag_action_equal (const GdkDragAction * s1,
                                 const GdkDragAction * s2);
VALA_EXTERN void sidebar_bookmark_row_highlight (SidebarBookmarkRow* self,
                                     gboolean show);
static gboolean ___lambda158__gtk_widget_drag_motion (GtkWidget* _sender,
                                               GdkDragContext* context,
                                               gint x,
                                               gint y,
                                               guint time_,
                                               gpointer self);
static void __lambda159_ (SidebarBookmarkRow* self);
static void ___lambda159__gtk_widget_drag_leave (GtkWidget* _sender,
                                          GdkDragContext* context,
                                          guint time_,
                                          gpointer self);
static gboolean __lambda160_ (SidebarBookmarkRow* self,
                       GdkDragContext* ctx,
                       gint x,
                       gint y,
                       guint time);
static gboolean ___lambda160__gtk_widget_drag_drop (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             guint time_,
                                             gpointer self);
VALA_EXTERN GtkWindow* files_get_active_window (void);
static GObject * sidebar_bookmark_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _sidebar_bookmark_row____lambda161_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row____lambda161__gtk_entry_activate (GtkEntry* _sender,
                                                              gpointer self);
static gboolean _sidebar_bookmark_row____lambda162_ (SidebarBookmarkRow* self);
static gboolean __sidebar_bookmark_row____lambda162__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                          GdkEventFocus* event,
                                                                          gpointer self);
static gboolean _sidebar_bookmark_row_on_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                        guint keyval,
                                                                                        guint keycode,
                                                                                        GdkModifierType state,
                                                                                        gpointer self);
static void _sidebar_bookmark_row_button_release_event_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                  gint n_press,
                                                                                  gdouble x,
                                                                                  gdouble y,
                                                                                  gpointer self);
static void _sidebar_bookmark_row___lambda163_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda163__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _sidebar_bookmark_row___lambda164_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda164__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void sidebar_bookmark_row_finalize (GObject * obj);
static GType sidebar_bookmark_row_get_type_once (void);
static void _vala_sidebar_bookmark_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_sidebar_bookmark_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sidebar_bookmark_row_get_instance_private (SidebarBookmarkRow* self)
{
	return G_STRUCT_MEMBER_P (self, SidebarBookmarkRow_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 353 "BookmarkRow.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 361 "BookmarkRow.c"
}

static GdkDragAction*
_gdk_drag_action_dup (GdkDragAction* self)
{
	GdkDragAction* dup;
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	dup = g_new0 (GdkDragAction, 1);
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	memcpy (dup, self, sizeof (GdkDragAction));
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	return dup;
#line 374 "BookmarkRow.c"
}

static gpointer
__gdk_drag_action_dup0 (gpointer self)
{
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	return self ? _gdk_drag_action_dup (self) : NULL;
#line 382 "BookmarkRow.c"
}

SidebarBookmarkRow*
sidebar_bookmark_row_construct (GType object_type,
                                const gchar* _custom_name,
                                const gchar* uri,
                                GIcon* gicon,
                                SidebarSidebarListInterface* list,
                                gboolean pinned,
                                gboolean permanent)
{
	SidebarBookmarkRow * self = NULL;
#line 93 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (_custom_name != NULL, NULL);
#line 93 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 93 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (gicon != NULL, NULL);
#line 93 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 99 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) g_object_new (object_type, "custom-name", _custom_name, "uri", uri, "gicon", gicon, "list", list, "hexpand", TRUE, "pinned", pinned, "permanent", permanent, NULL);
#line 93 "../src/View/Sidebar/BookmarkRow.vala"
	return self;
#line 407 "BookmarkRow.c"
}

SidebarBookmarkRow*
sidebar_bookmark_row_new (const gchar* _custom_name,
                          const gchar* uri,
                          GIcon* gicon,
                          SidebarSidebarListInterface* list,
                          gboolean pinned,
                          gboolean permanent)
{
#line 93 "../src/View/Sidebar/BookmarkRow.vala"
	return sidebar_bookmark_row_construct (SIDEBAR_TYPE_BOOKMARK_ROW, _custom_name, uri, gicon, list, pinned, permanent);
#line 420 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_update_plugin_data (SidebarSidebarItemInterface* base,
                                              FilesSidebarPluginItem* item)
{
	SidebarBookmarkRow * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GMenuModel* _tmp6_;
	GMenuModel* _tmp7_;
	GActionGroup* _tmp8_;
	GActionGroup* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
#line 196 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 196 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (item != NULL);
#line 197 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = files_sidebar_plugin_item_get_name (item);
#line 197 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 197 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_custom_name ((SidebarSidebarItemInterface*) self, _tmp1_);
#line 198 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = files_sidebar_plugin_item_get_uri (item);
#line 198 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 198 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_uri ((SidebarSidebarItemInterface*) self, _tmp3_);
#line 199 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = files_sidebar_plugin_item_get_icon (item);
#line 199 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 199 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_update_icon ((SidebarSidebarItemInterface*) self, _tmp5_);
#line 200 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = files_sidebar_plugin_item_get_menu_model (item);
#line 200 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = _tmp6_;
#line 200 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_menu_model ((SidebarSidebarItemInterface*) self, _tmp7_);
#line 201 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = files_sidebar_plugin_item_get_action_group (item);
#line 201 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = _tmp8_;
#line 201 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_action_group ((SidebarSidebarItemInterface*) self, _tmp9_);
#line 202 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = files_sidebar_plugin_item_get_action_group_namespace (item);
#line 202 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = _tmp10_;
#line 202 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_action_group_namespace ((SidebarSidebarItemInterface*) self, _tmp11_);
#line 480 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_rename (SidebarBookmarkRow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 205 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 206 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 206 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp1_) {
#line 496 "BookmarkRow.c"
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GtkStack* _tmp5_;
		GtkEntry* _tmp6_;
#line 207 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = self->editable;
#line 207 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp3_ = sidebar_bookmark_row_get_display_name (self);
#line 207 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = _tmp3_;
#line 207 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_entry_set_text (_tmp2_, _tmp4_);
#line 208 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = self->label_stack;
#line 208 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_stack_set_visible_child_name (_tmp5_, "editable");
#line 209 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = self->editable;
#line 209 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 518 "BookmarkRow.c"
	}
}

void
sidebar_bookmark_row_cancel_rename (SidebarBookmarkRow* self)
{
	GtkStack* _tmp0_;
#line 213 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label_stack;
#line 214 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "label");
#line 215 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 534 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_destroy_bookmark (SidebarSidebarItemInterface* base)
{
	SidebarBookmarkRow * self;
	GeeHashMap* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
#line 218 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 220 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->valid = FALSE;
#line 221 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_lock (&sidebar_sidebar_item_interface_item_map_lock);
#line 222 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_item_id_map;
#line 222 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 222 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 222 "../src/View/Sidebar/BookmarkRow.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) _tmp2_), NULL);
#line 223 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_unlock (&sidebar_sidebar_item_interface_item_map_lock);
#line 224 "../src/View/Sidebar/BookmarkRow.vala"
	GTK_WIDGET_CLASS (sidebar_bookmark_row_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 562 "BookmarkRow.c"
}

static gboolean
sidebar_bookmark_row_real_on_key_press_event (SidebarBookmarkRow* self,
                                              guint keyval,
                                              guint keycode,
                                              GdkModifierType state)
{
	gboolean result;
#line 228 "../src/View/Sidebar/BookmarkRow.vala"
	switch (keyval) {
#line 228 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_KEY_F2:
#line 576 "BookmarkRow.c"
		{
#line 230 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_bookmark_row_rename (self);
#line 231 "../src/View/Sidebar/BookmarkRow.vala"
			result = TRUE;
#line 231 "../src/View/Sidebar/BookmarkRow.vala"
			return result;
#line 584 "BookmarkRow.c"
		}
#line 228 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_KEY_Escape:
#line 588 "BookmarkRow.c"
		{
#line 234 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_bookmark_row_cancel_rename (self);
#line 235 "../src/View/Sidebar/BookmarkRow.vala"
			result = TRUE;
#line 235 "../src/View/Sidebar/BookmarkRow.vala"
			return result;
#line 596 "BookmarkRow.c"
		}
#line 228 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_KEY_Menu:
#line 600 "BookmarkRow.c"
		{
#line 238 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_bookmark_row_popup_context_menu (self);
#line 239 "../src/View/Sidebar/BookmarkRow.vala"
			result = TRUE;
#line 239 "../src/View/Sidebar/BookmarkRow.vala"
			return result;
#line 608 "BookmarkRow.c"
		}
		default:
		{
#line 242 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 614 "BookmarkRow.c"
		}
	}
#line 245 "../src/View/Sidebar/BookmarkRow.vala"
	result = FALSE;
#line 245 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 621 "BookmarkRow.c"
}

gboolean
sidebar_bookmark_row_on_key_press_event (SidebarBookmarkRow* self,
                                         guint keyval,
                                         guint keycode,
                                         GdkModifierType state)
{
	SidebarBookmarkRowClass* _klass_;
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_klass_ = SIDEBAR_BOOKMARK_ROW_GET_CLASS (self);
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	if (_klass_->on_key_press_event) {
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
		return _klass_->on_key_press_event (self, keyval, keycode, state);
#line 639 "BookmarkRow.c"
	}
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	return FALSE;
#line 643 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_button_release_event (SidebarBookmarkRow* self,
                                                gint n_press,
                                                gdouble x,
                                                gdouble y)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GdkModifierType state = 0U;
	GdkModifierType _tmp3_ = 0U;
	GdkModifierType mods = 0U;
	gboolean control_pressed = FALSE;
	gboolean other_mod_pressed = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean only_control_pressed = FALSE;
	GtkGestureMultiPress* _tmp5_;
#line 249 "../src/View/Sidebar/BookmarkRow.vala"
	if (!self->priv->valid) {
#line 250 "../src/View/Sidebar/BookmarkRow.vala"
		return;
#line 667 "BookmarkRow.c"
	}
#line 253 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label_stack;
#line 253 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 253 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 253 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (_tmp2_, "editable") == 0) {
#line 254 "../src/View/Sidebar/BookmarkRow.vala"
		return;
#line 679 "BookmarkRow.c"
	}
#line 258 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_get_current_event_state (&_tmp3_);
#line 258 "../src/View/Sidebar/BookmarkRow.vala"
	state = _tmp3_;
#line 259 "../src/View/Sidebar/BookmarkRow.vala"
	mods = state & gtk_accelerator_get_default_mod_mask ();
#line 260 "../src/View/Sidebar/BookmarkRow.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 261 "../src/View/Sidebar/BookmarkRow.vala"
	other_mod_pressed = ((mods & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
#line 262 "../src/View/Sidebar/BookmarkRow.vala"
	if (control_pressed) {
#line 262 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = !other_mod_pressed;
#line 695 "BookmarkRow.c"
	} else {
#line 262 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = FALSE;
#line 699 "BookmarkRow.c"
	}
#line 262 "../src/View/Sidebar/BookmarkRow.vala"
	only_control_pressed = _tmp4_;
#line 264 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = self->priv->button_controller;
#line 264 "../src/View/Sidebar/BookmarkRow.vala"
	switch (gtk_gesture_single_get_current_button ((GtkGestureSingle*) _tmp5_)) {
#line 264 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_BUTTON_PRIMARY:
#line 709 "BookmarkRow.c"
		{
#line 266 "../src/View/Sidebar/BookmarkRow.vala"
			if (only_control_pressed) {
#line 267 "../src/View/Sidebar/BookmarkRow.vala"
				sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_TAB);
#line 715 "BookmarkRow.c"
			}
#line 270 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 719 "BookmarkRow.c"
		}
#line 264 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_BUTTON_SECONDARY:
#line 723 "BookmarkRow.c"
		{
#line 272 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_bookmark_row_popup_context_menu (self);
#line 273 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 729 "BookmarkRow.c"
		}
#line 264 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_BUTTON_MIDDLE:
#line 733 "BookmarkRow.c"
		{
#line 276 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_TAB);
#line 277 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 739 "BookmarkRow.c"
		}
		default:
		{
#line 280 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 745 "BookmarkRow.c"
		}
	}
}

void
sidebar_bookmark_row_button_release_event (SidebarBookmarkRow* self,
                                           gint n_press,
                                           gdouble x,
                                           gdouble y)
{
	SidebarBookmarkRowClass* _klass_;
#line 248 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/View/Sidebar/BookmarkRow.vala"
	_klass_ = SIDEBAR_BOOKMARK_ROW_GET_CLASS (self);
#line 248 "../src/View/Sidebar/BookmarkRow.vala"
	if (_klass_->button_release_event) {
#line 248 "../src/View/Sidebar/BookmarkRow.vala"
		_klass_->button_release_event (self, n_press, x, y);
#line 765 "BookmarkRow.c"
	}
}

static void
__lambda148_ (SidebarBookmarkRow* self)
{
#line 286 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_DEFAULT);
#line 774 "BookmarkRow.c"
}

static void
___lambda148__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                    gpointer self)
{
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda148_ ((SidebarBookmarkRow*) self);
#line 783 "BookmarkRow.c"
}

static void
__lambda149_ (SidebarBookmarkRow* self)
{
#line 288 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_TAB);
#line 791 "BookmarkRow.c"
}

static void
___lambda149__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                    gpointer self)
{
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda149_ ((SidebarBookmarkRow*) self);
#line 800 "BookmarkRow.c"
}

static void
__lambda150_ (SidebarBookmarkRow* self)
{
#line 289 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_WINDOW);
#line 808 "BookmarkRow.c"
}

static void
___lambda150__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                    gpointer self)
{
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda150_ ((SidebarBookmarkRow*) self);
#line 817 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_popup_context_menu (SidebarBookmarkRow* self)
{
	PopupMenuBuilder* menu_builder = NULL;
	PopupMenuBuilder* _tmp0_;
	PopupMenuBuilder* _tmp1_;
	PopupMenuBuilder* _tmp2_;
	PopupMenuBuilder* _tmp3_;
	PopupMenuBuilder* _tmp4_;
	PopupMenuBuilder* _tmp5_;
	PopupMenuBuilder* _tmp6_;
	PopupMenuBuilder* _tmp7_;
	PopupMenuBuilder* _tmp8_;
	PopupMenuBuilder* _tmp9_;
	PopupMenuBuilder* _tmp10_;
	GMenuModel* _tmp11_;
	GMenuModel* _tmp12_;
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = popup_menu_builder_new ();
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = popup_menu_builder_add_open (_tmp1_, ___lambda148__popup_menu_builder_menuitem_callback, self);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = popup_menu_builder_add_separator (_tmp3_);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = popup_menu_builder_add_open_tab (_tmp5_, ___lambda149__popup_menu_builder_menuitem_callback, self);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = _tmp6_;
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = popup_menu_builder_add_open_window (_tmp7_, ___lambda150__popup_menu_builder_menuitem_callback, self);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = _tmp8_;
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (_tmp7_);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (_tmp5_);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (_tmp3_);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (_tmp1_);
#line 285 "../src/View/Sidebar/BookmarkRow.vala"
	menu_builder = _tmp9_;
#line 291 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = menu_builder;
#line 291 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_add_extra_menu_items ((SidebarSidebarItemInterface*) self, _tmp10_);
#line 293 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = sidebar_sidebar_item_interface_get_menu_model ((SidebarSidebarItemInterface*) self);
#line 293 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = _tmp11_;
#line 293 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp12_ != NULL) {
#line 877 "BookmarkRow.c"
		PopupMenuBuilder* _tmp13_;
		GMenuModel* _tmp14_;
		GMenuModel* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GActionGroup* _tmp18_;
		GActionGroup* _tmp19_;
		GtkMenu* _tmp20_;
		GtkMenu* _tmp21_;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp13_ = menu_builder;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp14_ = sidebar_sidebar_item_interface_get_menu_model ((SidebarSidebarItemInterface*) self);
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp15_ = _tmp14_;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp16_ = sidebar_sidebar_item_interface_get_action_group_namespace ((SidebarSidebarItemInterface*) self);
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp17_ = _tmp16_;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp18_ = sidebar_sidebar_item_interface_get_action_group ((SidebarSidebarItemInterface*) self);
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp19_ = _tmp18_;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp20_ = popup_menu_builder_build_from_model (_tmp13_, _tmp15_, _tmp17_, _tmp19_);
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp21_ = _tmp20_;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_menu_popup_at_pointer (_tmp21_, NULL);
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (_tmp21_);
#line 909 "BookmarkRow.c"
	} else {
		PopupMenuBuilder* _tmp22_;
		GtkMenu* _tmp23_;
		GtkMenu* _tmp24_;
#line 298 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp22_ = menu_builder;
#line 298 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp23_ = popup_menu_builder_build (_tmp22_);
#line 298 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp24_ = _tmp23_;
#line 298 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_menu_popup_at_pointer (_tmp24_, NULL);
#line 298 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (_tmp24_);
#line 924 "BookmarkRow.c"
	}
#line 284 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (menu_builder);
#line 928 "BookmarkRow.c"
}

void
sidebar_bookmark_row_popup_context_menu (SidebarBookmarkRow* self)
{
	SidebarBookmarkRowClass* _klass_;
#line 284 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/View/Sidebar/BookmarkRow.vala"
	_klass_ = SIDEBAR_BOOKMARK_ROW_GET_CLASS (self);
#line 284 "../src/View/Sidebar/BookmarkRow.vala"
	if (_klass_->popup_context_menu) {
#line 284 "../src/View/Sidebar/BookmarkRow.vala"
		_klass_->popup_context_menu (self);
#line 943 "BookmarkRow.c"
	}
}

static void
___lambda151_ (SidebarBookmarkRow* self)
{
	SidebarSidebarListInterface* _tmp0_;
	SidebarSidebarListInterface* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
#line 309 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 309 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 309 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 309 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 309 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_list_interface_remove_item_by_id (_tmp1_, _tmp3_);
#line 964 "BookmarkRow.c"
}

static void
____lambda151__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                     gpointer self)
{
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
	___lambda151_ ((SidebarBookmarkRow*) self);
#line 973 "BookmarkRow.c"
}

static void
___lambda152_ (SidebarBookmarkRow* self)
{
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_rename (self);
#line 981 "BookmarkRow.c"
}

static void
____lambda152__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                     gpointer self)
{
#line 313 "../src/View/Sidebar/BookmarkRow.vala"
	___lambda152_ ((SidebarBookmarkRow*) self);
#line 990 "BookmarkRow.c"
}

static void
___lambda153_ (SidebarBookmarkRow* self)
{
	GtkWidget* _tmp0_;
	FilesFileOperationsEmptyTrashJob* _tmp1_;
	FilesFileOperationsEmptyTrashJob* _tmp2_;
#line 322 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = gtk_widget_get_ancestor ((GtkWidget*) self, gtk_window_get_type ());
#line 322 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = marlin_file_operations_empty_trash_job_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow), NULL);
#line 322 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 322 "../src/View/Sidebar/BookmarkRow.vala"
	marlin_file_operations_empty_trash_job_empty_trash (_tmp2_, NULL, NULL);
#line 322 "../src/View/Sidebar/BookmarkRow.vala"
	_marlin_file_operations_common_job_unref0 (_tmp2_);
#line 1009 "BookmarkRow.c"
}

static void
____lambda153__popup_menu_builder_menuitem_callback (GtkMenuItem* menu_item,
                                                     gpointer self)
{
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
	___lambda153_ ((SidebarBookmarkRow*) self);
#line 1018 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_add_extra_menu_items (SidebarSidebarItemInterface* base,
                                                PopupMenuBuilder* menu_builder)
{
	SidebarBookmarkRow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
#line 304 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 304 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (menu_builder != NULL);
#line 306 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_permanent ((SidebarSidebarItemInterface*) self);
#line 306 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 306 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp1_) {
#line 1045 "BookmarkRow.c"
		PopupMenuBuilder* _tmp2_;
		PopupMenuBuilder* _tmp3_;
		PopupMenuBuilder* _tmp4_;
		PopupMenuBuilder* _tmp5_;
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = popup_menu_builder_add_separator (menu_builder);
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp3_ = _tmp2_;
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = popup_menu_builder_add_remove (_tmp3_, ____lambda151__popup_menu_builder_menuitem_callback, self);
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = _tmp4_;
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (_tmp5_);
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (_tmp3_);
#line 1062 "BookmarkRow.c"
	}
#line 312 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 312 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = _tmp6_;
#line 312 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp7_) {
#line 1070 "BookmarkRow.c"
		PopupMenuBuilder* _tmp8_;
		PopupMenuBuilder* _tmp9_;
#line 313 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = popup_menu_builder_add_rename (menu_builder, ____lambda152__popup_menu_builder_menuitem_callback, self);
#line 313 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp9_ = _tmp8_;
#line 313 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (_tmp9_);
#line 1079 "BookmarkRow.c"
	}
#line 318 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 318 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = _tmp10_;
#line 318 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = g_uri_parse_scheme (_tmp11_);
#line 318 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp13_ = _tmp12_;
#line 318 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp14_ = g_strcmp0 (_tmp13_, "trash") == 0;
#line 318 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp13_);
#line 318 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp14_) {
#line 1095 "BookmarkRow.c"
		PopupMenuBuilder* _tmp15_;
		PopupMenuBuilder* _tmp16_;
		PopupMenuBuilder* _tmp17_;
		PopupMenuBuilder* _tmp18_;
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp15_ = popup_menu_builder_add_separator (menu_builder);
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp16_ = _tmp15_;
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp17_ = popup_menu_builder_add_empty_all_trash (_tmp16_, ____lambda153__popup_menu_builder_menuitem_callback, self);
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp18_ = _tmp17_;
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (_tmp18_);
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (_tmp16_);
#line 1112 "BookmarkRow.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 358 "../src/View/Sidebar/BookmarkRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 1121 "BookmarkRow.c"
}

static void
__lambda154_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx)
{
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	cairo_surface_t* surface = NULL;
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_t* cr = NULL;
	cairo_t* _tmp4_;
	gboolean _tmp5_ = FALSE;
	cairo_surface_t* surface2 = NULL;
	GtkAllocation _tmp6_;
	GtkAllocation _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* cr2 = NULL;
	cairo_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	GdkDevice* device = NULL;
	GdkDevice* _tmp11_;
	GdkDevice* _tmp12_;
	gint x = 0;
	gint y = 0;
	GdkModifierType mask = 0U;
	GdkWindow* _tmp13_;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	GdkModifierType _tmp16_ = 0U;
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 346 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 346 "../src/View/Sidebar/BookmarkRow.vala"
	alloc = _tmp0_;
#line 347 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = alloc;
#line 347 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = alloc;
#line 347 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp1_.width, _tmp2_.height);
#line 347 "../src/View/Sidebar/BookmarkRow.vala"
	surface = _tmp3_;
#line 348 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = cairo_create (surface);
#line 348 "../src/View/Sidebar/BookmarkRow.vala"
	cr = _tmp4_;
#line 349 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_emit_by_name ((GtkWidget*) self, "draw", cr, &_tmp5_);
#line 351 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = alloc;
#line 351 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = alloc;
#line 351 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp6_.width, _tmp7_.height);
#line 351 "../src/View/Sidebar/BookmarkRow.vala"
	surface2 = _tmp8_;
#line 352 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = cairo_create (surface2);
#line 352 "../src/View/Sidebar/BookmarkRow.vala"
	cr2 = _tmp9_;
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = cairo_get_target (cr);
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_set_source_surface (cr2, _tmp10_, (gdouble) 0, (gdouble) 1);
#line 354 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_set_operator (cr2, CAIRO_OPERATOR_OVER);
#line 355 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_paint_with_alpha (cr2, 0.5);
#line 358 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = gtk_get_current_event_device ();
#line 358 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 358 "../src/View/Sidebar/BookmarkRow.vala"
	device = _tmp12_;
#line 361 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp13_ = gtk_widget_get_window ((GtkWidget*) self);
#line 361 "../src/View/Sidebar/BookmarkRow.vala"
	gdk_window_get_device_position (_tmp13_, device, &_tmp14_, &_tmp15_, &_tmp16_);
#line 361 "../src/View/Sidebar/BookmarkRow.vala"
	x = _tmp14_;
#line 361 "../src/View/Sidebar/BookmarkRow.vala"
	y = _tmp15_;
#line 361 "../src/View/Sidebar/BookmarkRow.vala"
	mask = _tmp16_;
#line 362 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_surface_set_device_offset (surface2, (gdouble) (-x), (gdouble) 0);
#line 364 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_drag_set_icon_surface (ctx, surface2);
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (device);
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_destroy0 (cr2);
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_surface_destroy0 (surface2);
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_destroy0 (cr);
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_surface_destroy0 (surface);
#line 1224 "BookmarkRow.c"
}

static void
___lambda154__gtk_widget_drag_begin (GtkWidget* _sender,
                                     GdkDragContext* context,
                                     gpointer self)
{
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda154_ ((SidebarBookmarkRow*) self, context);
#line 1234 "BookmarkRow.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1271 "BookmarkRow.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1277 "BookmarkRow.c"
}

static guint8*
_vala_array_dup3 (guint8* self,
                  gssize length)
{
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	if (length > 0) {
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 1288 "BookmarkRow.c"
	}
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	return NULL;
#line 1292 "BookmarkRow.c"
}

static void
__lambda155_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              GtkSelectionData* sel_data,
              guint info,
              guint time)
{
	guint8* data = NULL;
	guint32 _tmp0_;
	guint32 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint data_length1;
	gint _data_size_;
#line 369 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 369 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (sel_data != NULL);
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = g_strdup_printf ("%u", _tmp1_);
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = string_get_data (_tmp3_, &_tmp5_);
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4__length1 = _tmp5_;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = _tmp4_;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6__length1 = _tmp4__length1;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup3 (_tmp6_, _tmp6__length1) : _tmp6_;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7__length1 = _tmp6__length1;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = _tmp7_;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8__length1 = _tmp7__length1;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp3_);
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	data = _tmp8_;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	data_length1 = _tmp8__length1;
#line 370 "../src/View/Sidebar/BookmarkRow.vala"
	_data_size_ = data_length1;
#line 371 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_selection_data_set (sel_data, sidebar_bookmark_row_text_data_atom, 8, data, (gint) data_length1);
#line 369 "../src/View/Sidebar/BookmarkRow.vala"
	data = (g_free (data), NULL);
#line 1358 "BookmarkRow.c"
}

static void
___lambda155__gtk_widget_drag_data_get (GtkWidget* _sender,
                                        GdkDragContext* context,
                                        GtkSelectionData* selection_data,
                                        guint info,
                                        guint time_,
                                        gpointer self)
{
#line 369 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda155_ ((SidebarBookmarkRow*) self, context, selection_data, info, time_);
#line 1371 "BookmarkRow.c"
}

static void
__lambda156_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx)
{
#line 374 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 375 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_reset_drag_drop (self);
#line 1382 "BookmarkRow.c"
}

static void
___lambda156__gtk_widget_drag_end (GtkWidget* _sender,
                                   GdkDragContext* context,
                                   gpointer self)
{
#line 374 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda156_ ((SidebarBookmarkRow*) self, context);
#line 1392 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_set_up_drag (SidebarBookmarkRow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTargetEntry* _tmp2_;
	gint _tmp2__length1;
#line 331 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 332 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 332 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp1_) {
#line 333 "../src/View/Sidebar/BookmarkRow.vala"
		return;
#line 1412 "BookmarkRow.c"
	}
#line 336 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = sidebar_bookmark_row_source_targets;
#line 336 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2__length1 = sidebar_bookmark_row_source_targets_length1;
#line 336 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, _tmp2_, (gint) _tmp2__length1, GDK_ACTION_MOVE);
#line 343 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) ___lambda154__gtk_widget_drag_begin, self, 0);
#line 369 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) ___lambda155__gtk_widget_drag_data_get, self, 0);
#line 374 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-end", (GCallback) ___lambda156__gtk_widget_drag_end, self, 0);
#line 1426 "BookmarkRow.c"
}

static void
__lambda157_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              GtkSelectionData* sel_data,
              guint info,
              guint time)
{
#line 401 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 401 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (sel_data != NULL);
#line 402 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->drop_text);
#line 402 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_text = NULL;
#line 404 "../src/View/Sidebar/BookmarkRow.vala"
	switch (info) {
#line 404 "../src/View/Sidebar/BookmarkRow.vala"
		case FILES_TARGET_TYPE_BOOKMARK_ROW:
#line 1450 "BookmarkRow.c"
		{
			gchar* _tmp0_;
#line 406 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp0_ = gtk_selection_data_get_text (sel_data);
#line 406 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (self->priv->drop_text);
#line 406 "../src/View/Sidebar/BookmarkRow.vala"
			self->priv->drop_text = _tmp0_;
#line 407 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 1461 "BookmarkRow.c"
		}
#line 404 "../src/View/Sidebar/BookmarkRow.vala"
		case FILES_TARGET_TYPE_TEXT_URI_LIST:
#line 1465 "BookmarkRow.c"
		{
			gchar* _tmp1_ = NULL;
			gboolean _tmp2_;
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp2_ = files_dnd_handler_selection_data_is_uri_list (sel_data, info, &_tmp1_);
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (self->priv->drop_text);
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
			self->priv->drop_text = _tmp1_;
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
			if (!_tmp2_) {
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
				g_warning ("BookmarkRow.vala:411: sel data not uri list");
#line 412 "../src/View/Sidebar/BookmarkRow.vala"
				_g_free0 (self->priv->drop_text);
#line 412 "../src/View/Sidebar/BookmarkRow.vala"
				self->priv->drop_text = NULL;
#line 1483 "BookmarkRow.c"
			} else {
				const gchar* _tmp3_;
				GList* _tmp4_;
#line 414 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp3_ = self->priv->drop_text;
#line 414 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp4_ = files_file_utils_files_from_uris (_tmp3_);
#line 414 "../src/View/Sidebar/BookmarkRow.vala"
				(self->priv->drop_file_list == NULL) ? NULL : (self->priv->drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->drop_file_list), NULL));
#line 414 "../src/View/Sidebar/BookmarkRow.vala"
				self->priv->drop_file_list = _tmp4_;
#line 1495 "BookmarkRow.c"
			}
#line 417 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 1499 "BookmarkRow.c"
		}
		default:
		{
#line 420 "../src/View/Sidebar/BookmarkRow.vala"
			return;
#line 1505 "BookmarkRow.c"
		}
	}
#line 423 "../src/View/Sidebar/BookmarkRow.vala"
	if (self->priv->drop_occurred) {
#line 1510 "BookmarkRow.c"
		gboolean success = FALSE;
#line 424 "../src/View/Sidebar/BookmarkRow.vala"
		success = FALSE;
#line 425 "../src/View/Sidebar/BookmarkRow.vala"
		switch (info) {
#line 425 "../src/View/Sidebar/BookmarkRow.vala"
			case FILES_TARGET_TYPE_BOOKMARK_ROW:
#line 1518 "BookmarkRow.c"
			{
				const gchar* _tmp5_;
				GtkRevealer* _tmp6_;
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp5_ = self->priv->drop_text;
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp6_ = self->drop_revealer;
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp7_ = gtk_revealer_get_child_revealed (_tmp6_);
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp8_ = _tmp7_;
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
				success = sidebar_bookmark_row_process_dropped_row (self, _tmp5_, _tmp8_);
#line 431 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1536 "BookmarkRow.c"
			}
#line 425 "../src/View/Sidebar/BookmarkRow.vala"
			case FILES_TARGET_TYPE_TEXT_URI_LIST:
#line 1540 "BookmarkRow.c"
			{
				GList* _tmp9_;
				GtkRevealer* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 434 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp9_ = self->priv->drop_file_list;
#line 434 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp10_ = self->drop_revealer;
#line 434 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp11_ = gtk_revealer_get_child_revealed (_tmp10_);
#line 434 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp12_ = _tmp11_;
#line 434 "../src/View/Sidebar/BookmarkRow.vala"
				success = sidebar_bookmark_row_process_dropped_uris (self, gdk_drag_context_get_selected_action (ctx), gdk_drag_context_get_actions (ctx), _tmp9_, _tmp12_);
#line 440 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1558 "BookmarkRow.c"
			}
			default:
#line 425 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 1563 "BookmarkRow.c"
		}
#line 444 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_drag_finish (ctx, success, FALSE, (guint32) time);
#line 445 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_bookmark_row_reset_drag_drop (self);
#line 1569 "BookmarkRow.c"
	}
}

static void
___lambda157__gtk_widget_drag_data_received (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_,
                                             gpointer self)
{
#line 401 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda157_ ((SidebarBookmarkRow*) self, context, x, y, selection_data, info, time_);
#line 1585 "BookmarkRow.c"
}

static gboolean
_gdk_drag_action_equal (const GdkDragAction * s1,
                        const GdkDragAction * s2)
{
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
	if (s1 == s2) {
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
		return TRUE;
#line 1596 "BookmarkRow.c"
	}
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
	if (s1 == NULL) {
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
		return FALSE;
#line 1602 "BookmarkRow.c"
	}
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
	if (s2 == NULL) {
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
		return FALSE;
#line 1608 "BookmarkRow.c"
	}
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
	return (*s1) == (*s2);
#line 1612 "BookmarkRow.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1633 "BookmarkRow.c"
}

static gboolean
__lambda158_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              guint time)
{
	GdkAtom target = (GdkAtom) 0U;
	const gchar* _tmp0_;
	gint pos = 0;
	SidebarBookmarkRow* previous_item = NULL;
	SidebarSidebarListInterface* _tmp1_;
	SidebarSidebarListInterface* _tmp2_;
	SidebarSidebarItemInterface* _tmp3_;
	SidebarBookmarkRow* next_item = NULL;
	SidebarSidebarListInterface* _tmp4_;
	SidebarSidebarListInterface* _tmp5_;
	SidebarSidebarItemInterface* _tmp6_;
	SidebarBookmarkRow* _tmp7_;
	gint row_height = 0;
	GtkGrid* _tmp9_;
	gboolean reveal = FALSE;
	GdkDragAction _tmp10_;
	GdkDragAction* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GQuark _tmp15_ = 0U;
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
	static GQuark _tmp14_label0 = 0;
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
	static GQuark _tmp14_label1 = 0;
#line 1667 "BookmarkRow.c"
	GdkDragAction* _tmp58_;
	gboolean result;
#line 450 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 451 "../src/View/Sidebar/BookmarkRow.vala"
	target = gtk_drag_dest_find_target ((GtkWidget*) self, ctx, NULL);
#line 452 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->drop_text;
#line 452 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp0_ == NULL) {
#line 453 "../src/View/Sidebar/BookmarkRow.vala"
		if (target != GDK_NONE) {
#line 454 "../src/View/Sidebar/BookmarkRow.vala"
			gtk_drag_get_data ((GtkWidget*) self, ctx, target, (guint32) time);
#line 1682 "BookmarkRow.c"
		}
#line 457 "../src/View/Sidebar/BookmarkRow.vala"
		result = TRUE;
#line 457 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 1688 "BookmarkRow.c"
	}
#line 460 "../src/View/Sidebar/BookmarkRow.vala"
	pos = sidebar_sidebar_item_interface_get_index ((SidebarSidebarItemInterface*) self);
#line 461 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 461 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 461 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = sidebar_sidebar_list_interface_get_item_at_index (_tmp2_, pos - 1);
#line 461 "../src/View/Sidebar/BookmarkRow.vala"
	previous_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 462 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 462 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 462 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = sidebar_sidebar_list_interface_get_item_at_index (_tmp5_, pos + 1);
#line 462 "../src/View/Sidebar/BookmarkRow.vala"
	next_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 464 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = previous_item;
#line 464 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp7_ != NULL) {
#line 1712 "BookmarkRow.c"
		SidebarBookmarkRow* _tmp8_;
#line 465 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = previous_item;
#line 465 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_bookmark_row_reveal_drop_target (_tmp8_, FALSE);
#line 1718 "BookmarkRow.c"
	}
#line 468 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = self->icon_label_grid;
#line 468 "../src/View/Sidebar/BookmarkRow.vala"
	row_height = gtk_widget_get_allocated_height ((GtkWidget*) _tmp9_);
#line 469 "../src/View/Sidebar/BookmarkRow.vala"
	reveal = FALSE;
#line 471 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = GDK_ACTION_DEFAULT;
#line 471 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = __gdk_drag_action_dup0 (&_tmp10_);
#line 471 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->current_suggested_action);
#line 471 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->current_suggested_action = _tmp11_;
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = gdk_atom_name (target);
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp13_ = _tmp12_;
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp15_ = (NULL == _tmp13_) ? 0 : g_quark_from_string (_tmp13_);
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
	g_free (_tmp13_);
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp15_ == ((0 != _tmp14_label0) ? _tmp14_label0 : (_tmp14_label0 = g_quark_from_static_string ("text/plain")))) {
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
		switch (0) {
#line 1746 "BookmarkRow.c"
			default:
			{
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
				gboolean _tmp18_;
				gboolean _tmp19_;
#line 474 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp18_ = sidebar_sidebar_item_interface_get_can_insert_after ((SidebarSidebarItemInterface*) self);
#line 474 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp19_ = _tmp18_;
#line 474 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp19_) {
#line 1759 "BookmarkRow.c"
					gboolean _tmp20_ = FALSE;
					SidebarBookmarkRow* _tmp21_;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp21_ = next_item;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
					if (_tmp21_ == NULL) {
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp20_ = TRUE;
#line 1768 "BookmarkRow.c"
					} else {
						SidebarBookmarkRow* _tmp22_;
						gboolean _tmp23_;
						gboolean _tmp24_;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp22_ = next_item;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp23_ = sidebar_sidebar_item_interface_get_can_insert_before ((SidebarSidebarItemInterface*) _tmp22_);
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp24_ = _tmp23_;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp20_ = _tmp24_;
#line 1781 "BookmarkRow.c"
					}
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp17_ = _tmp20_;
#line 1785 "BookmarkRow.c"
				} else {
#line 474 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp17_ = FALSE;
#line 1789 "BookmarkRow.c"
				}
#line 474 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp17_) {
#line 476 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp16_ = y > (row_height / 2);
#line 1795 "BookmarkRow.c"
				} else {
#line 474 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp16_ = FALSE;
#line 1799 "BookmarkRow.c"
				}
#line 474 "../src/View/Sidebar/BookmarkRow.vala"
				reveal = _tmp16_;
#line 478 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1805 "BookmarkRow.c"
			}
		}
	} else if (_tmp15_ == ((0 != _tmp14_label1) ? _tmp14_label1 : (_tmp14_label1 = g_quark_from_static_string ("text/uri-list")))) {
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
		switch (0) {
#line 1811 "BookmarkRow.c"
			default:
			{
				gboolean _tmp25_ = FALSE;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_;
				gboolean _tmp28_;
				gboolean _tmp34_ = FALSE;
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp27_ = sidebar_sidebar_item_interface_get_can_insert_after ((SidebarSidebarItemInterface*) self);
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp28_ = _tmp27_;
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp28_) {
#line 1825 "BookmarkRow.c"
					gboolean _tmp29_ = FALSE;
					SidebarBookmarkRow* _tmp30_;
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp30_ = next_item;
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
					if (_tmp30_ == NULL) {
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp29_ = TRUE;
#line 1834 "BookmarkRow.c"
					} else {
						SidebarBookmarkRow* _tmp31_;
						gboolean _tmp32_;
						gboolean _tmp33_;
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp31_ = next_item;
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp32_ = sidebar_sidebar_item_interface_get_can_insert_before ((SidebarSidebarItemInterface*) _tmp31_);
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp33_ = _tmp32_;
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp29_ = _tmp33_;
#line 1847 "BookmarkRow.c"
					}
#line 482 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp26_ = _tmp29_;
#line 1851 "BookmarkRow.c"
				} else {
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp26_ = FALSE;
#line 1855 "BookmarkRow.c"
				}
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp26_) {
#line 483 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp25_ = y > (row_height - 1);
#line 1861 "BookmarkRow.c"
				} else {
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp25_ = FALSE;
#line 1865 "BookmarkRow.c"
				}
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
				reveal = _tmp25_;
#line 486 "../src/View/Sidebar/BookmarkRow.vala"
				if (!reveal) {
#line 1871 "BookmarkRow.c"
					GList* _tmp35_;
#line 486 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp35_ = self->priv->drop_file_list;
#line 486 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp34_ = _tmp35_ != NULL;
#line 1877 "BookmarkRow.c"
				} else {
#line 486 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp34_ = FALSE;
#line 1881 "BookmarkRow.c"
				}
#line 486 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp34_) {
#line 1885 "BookmarkRow.c"
					FilesFile* _tmp36_;
					GList* _tmp37_;
					GdkDragAction _tmp38_ = 0U;
					GdkDragAction _tmp39_;
					GdkDragAction* _tmp40_;
					GdkDragAction* _tmp41_;
					GdkDragAction _tmp42_;
#line 487 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp36_ = self->priv->target_file;
#line 487 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp37_ = self->priv->drop_file_list;
#line 487 "../src/View/Sidebar/BookmarkRow.vala"
					files_dnd_handler_file_accepts_drop (_tmp36_, _tmp37_, gdk_drag_context_get_selected_action (ctx), gdk_drag_context_get_actions (ctx), &_tmp38_);
#line 487 "../src/View/Sidebar/BookmarkRow.vala"
					_g_free0 (self->priv->current_suggested_action);
#line 487 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp39_ = _tmp38_;
#line 487 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp40_ = __gdk_drag_action_dup0 (&_tmp39_);
#line 487 "../src/View/Sidebar/BookmarkRow.vala"
					self->priv->current_suggested_action = _tmp40_;
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp41_ = self->priv->current_suggested_action;
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp42_ = GDK_ACTION_DEFAULT;
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
					if (_gdk_drag_action_equal (_tmp41_, &_tmp42_) != TRUE) {
#line 496 "../src/View/Sidebar/BookmarkRow.vala"
						sidebar_bookmark_row_highlight (self, TRUE);
#line 1915 "BookmarkRow.c"
					}
				} else {
#line 499 "../src/View/Sidebar/BookmarkRow.vala"
					sidebar_bookmark_row_highlight (self, FALSE);
#line 1920 "BookmarkRow.c"
				}
#line 502 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1924 "BookmarkRow.c"
			}
		}
	} else {
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
		switch (0) {
#line 1930 "BookmarkRow.c"
			default:
			{
#line 504 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1935 "BookmarkRow.c"
			}
		}
	}
#line 507 "../src/View/Sidebar/BookmarkRow.vala"
	if (sidebar_bookmark_row_reveal_drop_target (self, reveal)) {
#line 1941 "BookmarkRow.c"
		GdkDragAction _tmp43_;
		GdkDragAction* _tmp44_;
		gboolean _tmp45_ = FALSE;
		gboolean _tmp46_ = FALSE;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gboolean _tmp49_;
#line 508 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp43_ = GDK_ACTION_LINK;
#line 508 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp44_ = __gdk_drag_action_dup0 (&_tmp43_);
#line 508 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->current_suggested_action);
#line 508 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->current_suggested_action = _tmp44_;
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp47_ = gdk_atom_name (target);
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp48_ = _tmp47_;
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp49_ = g_strcmp0 (_tmp48_, "text/uri-list") == 0;
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (_tmp48_);
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp49_) {
#line 1967 "BookmarkRow.c"
			const gchar* _tmp50_;
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp50_ = self->priv->drop_text;
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp46_ = _tmp50_ != NULL;
#line 1973 "BookmarkRow.c"
		} else {
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp46_ = FALSE;
#line 1977 "BookmarkRow.c"
		}
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp46_) {
#line 1981 "BookmarkRow.c"
			SidebarSidebarListInterface* _tmp51_;
			SidebarSidebarListInterface* _tmp52_;
			const gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp51_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp52_ = _tmp51_;
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp53_ = self->priv->drop_text;
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp54_ = string_strip (_tmp53_);
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp55_ = _tmp54_;
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp45_ = sidebar_sidebar_list_interface_has_uri (_tmp52_, _tmp55_, NULL);
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (_tmp55_);
#line 2001 "BookmarkRow.c"
		} else {
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp45_ = FALSE;
#line 2005 "BookmarkRow.c"
		}
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp45_) {
#line 2009 "BookmarkRow.c"
			GdkDragAction _tmp56_;
			GdkDragAction* _tmp57_;
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp56_ = GDK_ACTION_DEFAULT;
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp57_ = __gdk_drag_action_dup0 (&_tmp56_);
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (self->priv->current_suggested_action);
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
			self->priv->current_suggested_action = _tmp57_;
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
			reveal = FALSE;
#line 2022 "BookmarkRow.c"
		}
	}
#line 517 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp58_ = self->priv->current_suggested_action;
#line 517 "../src/View/Sidebar/BookmarkRow.vala"
	gdk_drag_status (ctx, *_tmp58_, (guint32) time);
#line 518 "../src/View/Sidebar/BookmarkRow.vala"
	result = TRUE;
#line 518 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (next_item);
#line 518 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (previous_item);
#line 518 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2037 "BookmarkRow.c"
}

static gboolean
___lambda158__gtk_widget_drag_motion (GtkWidget* _sender,
                                      GdkDragContext* context,
                                      gint x,
                                      gint y,
                                      guint time_,
                                      gpointer self)
{
	gboolean result;
	result = __lambda158_ ((SidebarBookmarkRow*) self, context, x, y, time_);
#line 450 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2052 "BookmarkRow.c"
}

static void
__lambda159_ (SidebarBookmarkRow* self)
{
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_reset_drag_drop (self);
#line 2060 "BookmarkRow.c"
}

static void
___lambda159__gtk_widget_drag_leave (GtkWidget* _sender,
                                     GdkDragContext* context,
                                     guint time_,
                                     gpointer self)
{
#line 521 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda159_ ((SidebarBookmarkRow*) self);
#line 2071 "BookmarkRow.c"
}

static gboolean
__lambda160_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              guint time)
{
	GdkAtom target = (GdkAtom) 0U;
	gboolean result;
#line 525 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 526 "../src/View/Sidebar/BookmarkRow.vala"
	target = gtk_drag_dest_find_target ((GtkWidget*) self, ctx, NULL);
#line 527 "../src/View/Sidebar/BookmarkRow.vala"
	if (target != GDK_NONE) {
#line 531 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->drop_occurred = TRUE;
#line 532 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_drag_get_data ((GtkWidget*) self, ctx, target, (guint32) time);
#line 2093 "BookmarkRow.c"
	} else {
#line 534 "../src/View/Sidebar/BookmarkRow.vala"
		result = FALSE;
#line 534 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2099 "BookmarkRow.c"
	}
#line 537 "../src/View/Sidebar/BookmarkRow.vala"
	result = TRUE;
#line 537 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2105 "BookmarkRow.c"
}

static gboolean
___lambda160__gtk_widget_drag_drop (GtkWidget* _sender,
                                    GdkDragContext* context,
                                    gint x,
                                    gint y,
                                    guint time_,
                                    gpointer self)
{
	gboolean result;
	result = __lambda160_ ((SidebarBookmarkRow*) self, context, x, y, time_);
#line 525 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2120 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_set_up_drop (SidebarBookmarkRow* self)
{
	GtkSeparator* drop_revealer_child = NULL;
	GtkSeparator* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	GtkRevealer* _tmp2_ = NULL;
	GtkRevealer* _tmp3_;
	GtkGrid* _tmp4_;
	GtkRevealer* _tmp5_;
	GtkTargetEntry* _tmp6_;
	gint _tmp6__length1;
#line 380 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 381 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 381 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, 12);
#line 381 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp0_, 0);
#line 381 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp0_);
#line 381 "../src/View/Sidebar/BookmarkRow.vala"
	drop_revealer_child = _tmp0_;
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) drop_revealer_child);
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = (GtkRevealer*) gtk_revealer_new ();
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_set ((GtkContainer*) _tmp2_, "child", _tmp1_, NULL);
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (_tmp1_);
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_revealer_set_transition_type (_tmp2_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp2_);
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->drop_revealer);
#line 386 "../src/View/Sidebar/BookmarkRow.vala"
	self->drop_revealer = _tmp2_;
#line 390 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = self->drop_revealer;
#line 390 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 392 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = self->content_grid;
#line 392 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = self->drop_revealer;
#line 392 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_attach (_tmp4_, (GtkWidget*) _tmp5_, 0, 1, 1, 1);
#line 394 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = sidebar_bookmark_row_dest_targets;
#line 394 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6__length1 = sidebar_bookmark_row_dest_targets_length1;
#line 394 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT, _tmp6_, (gint) _tmp6__length1, ((GDK_ACTION_MOVE | GDK_ACTION_COPY) | GDK_ACTION_LINK) | GDK_ACTION_ASK);
#line 401 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-received", (GCallback) ___lambda157__gtk_widget_drag_data_received, self, 0);
#line 450 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-motion", (GCallback) ___lambda158__gtk_widget_drag_motion, self, 0);
#line 521 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-leave", (GCallback) ___lambda159__gtk_widget_drag_leave, self, 0);
#line 525 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-drop", (GCallback) ___lambda160__gtk_widget_drag_drop, self, 0);
#line 380 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (drop_revealer_child);
#line 2189 "BookmarkRow.c"
}

void
sidebar_bookmark_row_highlight (SidebarBookmarkRow* self,
                                gboolean show)
{
	gboolean _tmp0_ = FALSE;
#line 541 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 542 "../src/View/Sidebar/BookmarkRow.vala"
	if (show) {
#line 2201 "BookmarkRow.c"
		GtkStyleContext* _tmp1_;
#line 542 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 542 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = !gtk_style_context_has_class (_tmp1_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2207 "BookmarkRow.c"
	} else {
#line 542 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = FALSE;
#line 2211 "BookmarkRow.c"
	}
#line 542 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp0_) {
#line 2215 "BookmarkRow.c"
		GtkStyleContext* _tmp2_;
#line 543 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 543 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2221 "BookmarkRow.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 544 "../src/View/Sidebar/BookmarkRow.vala"
		if (!show) {
#line 2226 "BookmarkRow.c"
			GtkStyleContext* _tmp4_;
#line 544 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 544 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp3_ = gtk_style_context_has_class (_tmp4_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2232 "BookmarkRow.c"
		} else {
#line 544 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp3_ = FALSE;
#line 2236 "BookmarkRow.c"
		}
#line 544 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp3_) {
#line 2240 "BookmarkRow.c"
			GtkStyleContext* _tmp5_;
#line 545 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 545 "../src/View/Sidebar/BookmarkRow.vala"
			gtk_style_context_remove_class (_tmp5_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2246 "BookmarkRow.c"
		}
	}
}

static void
sidebar_bookmark_row_reset_drag_drop (SidebarBookmarkRow* self)
{
	GdkDragAction _tmp0_;
	GdkDragAction* _tmp1_;
#line 549 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
	(self->priv->drop_file_list == NULL) ? NULL : (self->priv->drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->drop_file_list), NULL));
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_file_list = NULL;
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->drop_text);
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_text = NULL;
#line 552 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_occurred = FALSE;
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = GDK_ACTION_DEFAULT;
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = __gdk_drag_action_dup0 (&_tmp0_);
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->current_suggested_action);
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->current_suggested_action = _tmp1_;
#line 554 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_reveal_drop_target (self, FALSE);
#line 555 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_highlight (self, FALSE);
#line 2280 "BookmarkRow.c"
}

static guint
uint_parse (const gchar* str,
            guint _base)
{
	guint result;
#line 213 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0U);
#line 214 "glib-2.0.vapi"
	result = (guint) strtoul (str, NULL, (gint) _base);
#line 214 "glib-2.0.vapi"
	return result;
#line 2294 "BookmarkRow.c"
}

static gboolean
sidebar_bookmark_row_process_dropped_row (SidebarBookmarkRow* self,
                                          const gchar* drop_text,
                                          gboolean dropped_between)
{
	guint32 id = 0U;
	SidebarSidebarItemInterface* item = NULL;
	SidebarSidebarItemInterface* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	SidebarSidebarItemInterface* _tmp3_;
	SidebarSidebarListInterface* _tmp9_;
	SidebarSidebarListInterface* _tmp10_;
	SidebarSidebarItemInterface* _tmp11_;
	gboolean result;
#line 558 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 558 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (drop_text != NULL, FALSE);
#line 559 "../src/View/Sidebar/BookmarkRow.vala"
	id = (guint32) uint_parse (drop_text, (guint) 0);
#line 560 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_item (id);
#line 560 "../src/View/Sidebar/BookmarkRow.vala"
	item = _tmp0_;
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = item;
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp3_ == NULL) {
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = TRUE;
#line 2328 "BookmarkRow.c"
	} else {
#line 563 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = !dropped_between;
#line 2332 "BookmarkRow.c"
	}
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp2_) {
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = TRUE;
#line 2338 "BookmarkRow.c"
	} else {
		SidebarSidebarItemInterface* _tmp4_;
		SidebarSidebarListInterface* _tmp5_;
		SidebarSidebarListInterface* _tmp6_;
		SidebarSidebarListInterface* _tmp7_;
		SidebarSidebarListInterface* _tmp8_;
#line 564 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = item;
#line 564 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = sidebar_sidebar_item_interface_get_list (_tmp4_);
#line 564 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = _tmp5_;
#line 564 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 564 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = _tmp7_;
#line 564 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = _tmp6_ != _tmp8_;
#line 2357 "BookmarkRow.c"
	}
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp1_) {
#line 566 "../src/View/Sidebar/BookmarkRow.vala"
		result = FALSE;
#line 566 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (item);
#line 566 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2367 "BookmarkRow.c"
	}
#line 569 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 569 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = _tmp9_;
#line 569 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = item;
#line 569 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_list_interface_move_item_after (_tmp10_, _tmp11_, sidebar_sidebar_item_interface_get_index ((SidebarSidebarItemInterface*) self));
#line 570 "../src/View/Sidebar/BookmarkRow.vala"
	result = TRUE;
#line 570 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (item);
#line 570 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2383 "BookmarkRow.c"
}

static gboolean
sidebar_bookmark_row_process_dropped_uris (SidebarBookmarkRow* self,
                                           GdkDragAction selected_action,
                                           GdkDragAction possible_actions,
                                           GList* drop_file_list,
                                           gboolean dropped_between)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 573 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 578 "../src/View/Sidebar/BookmarkRow.vala"
	if (dropped_between) {
#line 2399 "BookmarkRow.c"
		GList* _tmp1_;
#line 578 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = drop_file_list->next;
#line 578 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 2405 "BookmarkRow.c"
	} else {
#line 578 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = FALSE;
#line 2409 "BookmarkRow.c"
	}
#line 578 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp0_) {
#line 2413 "BookmarkRow.c"
		gint pos = 0;
		gint _tmp2_;
		SidebarSidebarListInterface* _tmp3_;
		SidebarSidebarListInterface* _tmp4_;
		gconstpointer _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
#line 579 "../src/View/Sidebar/BookmarkRow.vala"
		pos = sidebar_sidebar_item_interface_get_index ((SidebarSidebarItemInterface*) self);
#line 580 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = pos;
#line 580 "../src/View/Sidebar/BookmarkRow.vala"
		pos = _tmp2_ + 1;
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp3_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = _tmp3_;
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = drop_file_list->data;
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = g_file_get_uri ((GFile*) _tmp5_);
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = _tmp6_;
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = sidebar_sidebar_list_interface_add_favorite (_tmp4_, _tmp7_, "", pos);
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (_tmp7_);
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		result = _tmp8_;
#line 581 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2446 "BookmarkRow.c"
	} else {
		FilesDndHandler* dnd_handler = NULL;
		FilesDndHandler* _tmp9_;
		GdkDragAction real_action = 0U;
		FilesDndHandler* _tmp17_;
		FilesFile* _tmp18_;
#line 583 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp9_ = files_dnd_handler_new ();
#line 583 "../src/View/Sidebar/BookmarkRow.vala"
		dnd_handler = _tmp9_;
#line 584 "../src/View/Sidebar/BookmarkRow.vala"
		real_action = selected_action;
#line 586 "../src/View/Sidebar/BookmarkRow.vala"
		if (real_action == GDK_ACTION_ASK) {
#line 2461 "BookmarkRow.c"
			GdkDragAction actions = 0U;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			FilesDndHandler* _tmp12_;
			GtkWindow* _tmp13_;
			GtkApplicationWindow* _tmp14_;
			GdkDragAction* _tmp15_;
			GdkDragAction* _tmp16_;
#line 587 "../src/View/Sidebar/BookmarkRow.vala"
			actions = possible_actions;
#line 589 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp10_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 589 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp11_ = _tmp10_;
#line 589 "../src/View/Sidebar/BookmarkRow.vala"
			if (g_str_has_prefix (_tmp11_, "trash://")) {
#line 590 "../src/View/Sidebar/BookmarkRow.vala"
				actions &= GDK_ACTION_MOVE;
#line 2480 "BookmarkRow.c"
			}
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp12_ = dnd_handler;
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp13_ = files_get_active_window ();
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_application_window_get_type (), GtkApplicationWindow);
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp15_ = files_dnd_handler_drag_drop_action_ask (_tmp12_, (GtkWidget*) self, _tmp14_, actions);
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp16_ = _tmp15_;
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			real_action = *_tmp16_;
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (_tmp16_);
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
			_g_object_unref0 (_tmp14_);
#line 2498 "BookmarkRow.c"
		}
#line 600 "../src/View/Sidebar/BookmarkRow.vala"
		if (real_action == 0) {
#line 601 "../src/View/Sidebar/BookmarkRow.vala"
			result = FALSE;
#line 601 "../src/View/Sidebar/BookmarkRow.vala"
			_g_object_unref0 (dnd_handler);
#line 601 "../src/View/Sidebar/BookmarkRow.vala"
			return result;
#line 2508 "BookmarkRow.c"
		}
#line 604 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp17_ = dnd_handler;
#line 604 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp18_ = self->priv->target_file;
#line 604 "../src/View/Sidebar/BookmarkRow.vala"
		files_dnd_handler_dnd_perform (_tmp17_, (GtkWidget*) self, _tmp18_, drop_file_list, real_action);
#line 611 "../src/View/Sidebar/BookmarkRow.vala"
		result = TRUE;
#line 611 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (dnd_handler);
#line 611 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2522 "BookmarkRow.c"
	}
}

gboolean
sidebar_bookmark_row_reveal_drop_target (SidebarBookmarkRow* self,
                                         gboolean reveal)
{
	SidebarSidebarListInterface* _tmp0_;
	SidebarSidebarListInterface* _tmp1_;
	gboolean result;
#line 615 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 616 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 616 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 616 "../src/View/Sidebar/BookmarkRow.vala"
	if (sidebar_sidebar_list_interface_is_drop_target (_tmp1_)) {
#line 2541 "BookmarkRow.c"
		GtkRevealer* _tmp2_;
#line 617 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = self->drop_revealer;
#line 617 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_revealer_set_reveal_child (_tmp2_, reveal);
#line 618 "../src/View/Sidebar/BookmarkRow.vala"
		result = reveal;
#line 618 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2551 "BookmarkRow.c"
	} else {
#line 620 "../src/View/Sidebar/BookmarkRow.vala"
		result = FALSE;
#line 620 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2557 "BookmarkRow.c"
	}
}

static const gchar*
sidebar_bookmark_row_real_get_custom_name (SidebarSidebarItemInterface* base)
{
	const gchar* result;
	SidebarBookmarkRow* self;
	const gchar* _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_custom_name;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2575 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_custom_name (SidebarSidebarItemInterface* base,
                                           const gchar* value)
{
	SidebarBookmarkRow* self;
	gchar* old_value;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_custom_name (base);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2590 "BookmarkRow.c"
		gchar* _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = g_strdup (value);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->_custom_name);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_custom_name = _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY]);
#line 2600 "BookmarkRow.c"
	}
}

const gchar*
sidebar_bookmark_row_get_display_name (SidebarBookmarkRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 71 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "") != 0;
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp3_);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp4_) {
#line 2629 "BookmarkRow.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = _tmp5_;
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		result = _tmp6_;
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2640 "BookmarkRow.c"
	} else {
		FilesFile* _tmp7_;
		const gchar* _tmp8_;
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = self->priv->target_file;
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = files_file_get_display_name (_tmp7_);
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		result = _tmp8_;
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2652 "BookmarkRow.c"
	}
}

static SidebarSidebarListInterface*
sidebar_bookmark_row_real_get_list (SidebarSidebarItemInterface* base)
{
	SidebarSidebarListInterface* result;
	SidebarBookmarkRow* self;
	SidebarSidebarListInterface* _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_list;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2670 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_list (SidebarSidebarItemInterface* base,
                                    SidebarSidebarListInterface* value)
{
	SidebarBookmarkRow* self;
	SidebarSidebarListInterface* old_value;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_list (base);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 2685 "BookmarkRow.c"
		SidebarSidebarListInterface* _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_list);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_list = _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY]);
#line 2695 "BookmarkRow.c"
	}
}

static guint32
sidebar_bookmark_row_real_get_id (SidebarSidebarItemInterface* base)
{
	guint32 result;
	SidebarBookmarkRow* self;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_id;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2710 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_id (SidebarSidebarItemInterface* base,
                                  guint32 value)
{
	SidebarBookmarkRow* self;
	guint32 old_value;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_id (base);
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_id = value;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ID_PROPERTY]);
#line 2729 "BookmarkRow.c"
	}
}

static const gchar*
sidebar_bookmark_row_real_get_uri (SidebarSidebarItemInterface* base)
{
	const gchar* result;
	SidebarBookmarkRow* self;
	const gchar* _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_uri;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2747 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_uri (SidebarSidebarItemInterface* base,
                                   const gchar* value)
{
	SidebarBookmarkRow* self;
	gchar* old_value;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_uri (base);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2762 "BookmarkRow.c"
		gchar* _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = g_strdup (value);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->_uri);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_uri = _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_URI_PROPERTY]);
#line 2772 "BookmarkRow.c"
	}
}

static GIcon*
sidebar_bookmark_row_real_get_gicon (SidebarSidebarItemInterface* base)
{
	GIcon* result;
	SidebarBookmarkRow* self;
	GIcon* _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_gicon;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2790 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_gicon (SidebarSidebarItemInterface* base,
                                     GIcon* value)
{
	SidebarBookmarkRow* self;
	GIcon* old_value;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_gicon (base);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 2805 "BookmarkRow.c"
		GIcon* _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_gicon);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_gicon = _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY]);
#line 2815 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_pinned (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_pinned;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2830 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_pinned (SidebarSidebarItemInterface* base,
                                      gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_pinned (base);
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_pinned = value;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY]);
#line 2849 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_permanent (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_permanent;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2864 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_permanent (SidebarSidebarItemInterface* base,
                                         gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_permanent (base);
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_permanent = value;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY]);
#line 2883 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_can_insert_before (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_can_insert_before;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2898 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_can_insert_before (SidebarSidebarItemInterface* base,
                                                 gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_can_insert_before (base);
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_can_insert_before = value;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY]);
#line 2917 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_can_insert_after (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_can_insert_after;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2932 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_can_insert_after (SidebarSidebarItemInterface* base,
                                                gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_can_insert_after (base);
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_can_insert_after = value;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY]);
#line 2951 "BookmarkRow.c"
	}
}

static GMenuModel*
sidebar_bookmark_row_real_get_menu_model (SidebarSidebarItemInterface* base)
{
	GMenuModel* result;
	SidebarBookmarkRow* self;
	GMenuModel* _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_menu_model;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2969 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_menu_model (SidebarSidebarItemInterface* base,
                                          GMenuModel* value)
{
	SidebarBookmarkRow* self;
	GMenuModel* old_value;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_menu_model (base);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 2984 "BookmarkRow.c"
		GMenuModel* _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_menu_model);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_menu_model = _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY]);
#line 2994 "BookmarkRow.c"
	}
}

static GActionGroup*
sidebar_bookmark_row_real_get_action_group (SidebarSidebarItemInterface* base)
{
	GActionGroup* result;
	SidebarBookmarkRow* self;
	GActionGroup* _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_action_group;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 3012 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_action_group (SidebarSidebarItemInterface* base,
                                            GActionGroup* value)
{
	SidebarBookmarkRow* self;
	GActionGroup* old_value;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_action_group (base);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 3027 "BookmarkRow.c"
		GActionGroup* _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_action_group);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_action_group = _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY]);
#line 3037 "BookmarkRow.c"
	}
}

static const gchar*
sidebar_bookmark_row_real_get_action_group_namespace (SidebarSidebarItemInterface* base)
{
	const gchar* result;
	SidebarBookmarkRow* self;
	const gchar* _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_action_group_namespace;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 3055 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_action_group_namespace (SidebarSidebarItemInterface* base,
                                                      const gchar* value)
{
	SidebarBookmarkRow* self;
	gchar* old_value;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_action_group_namespace (base);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3070 "BookmarkRow.c"
		gchar* _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = g_strdup (value);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->_action_group_namespace);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_action_group_namespace = _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY]);
#line 3080 "BookmarkRow.c"
	}
}

static void
_sidebar_bookmark_row____lambda161_ (SidebarBookmarkRow* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkStack* _tmp14_;
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = self->editable;
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = _tmp3_;
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (_tmp1_, _tmp4_) != 0) {
#line 3105 "BookmarkRow.c"
		GtkEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		SidebarSidebarListInterface* _tmp8_;
		SidebarSidebarListInterface* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 142 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = self->editable;
#line 142 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 142 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = _tmp6_;
#line 142 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_custom_name ((SidebarSidebarItemInterface*) self, _tmp7_);
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp9_ = _tmp8_;
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp10_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp11_ = _tmp10_;
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp12_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp13_ = _tmp12_;
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_list_interface_rename_bookmark_by_uri (_tmp9_, _tmp11_, _tmp13_);
#line 3137 "BookmarkRow.c"
	}
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp14_ = self->label_stack;
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp14_, "label");
#line 3143 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row____lambda161__gtk_entry_activate (GtkEntry* _sender,
                                                         gpointer self)
{
#line 140 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row____lambda161_ ((SidebarBookmarkRow*) self);
#line 3152 "BookmarkRow.c"
}

static gboolean
_sidebar_bookmark_row____lambda162_ (SidebarBookmarkRow* self)
{
	GtkStack* _tmp0_;
#line 149 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label_stack;
#line 149 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "label");
#line 3163 "BookmarkRow.c"
}

static gboolean
__sidebar_bookmark_row____lambda162__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                 GdkEventFocus* event,
                                                                 gpointer self)
{
	gboolean result;
	result = _sidebar_bookmark_row____lambda162_ ((SidebarBookmarkRow*) self);
#line 148 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 3175 "BookmarkRow.c"
}

static gboolean
_sidebar_bookmark_row_on_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                               guint keyval,
                                                                               guint keycode,
                                                                               GdkModifierType state,
                                                                               gpointer self)
{
	gboolean result;
	result = sidebar_bookmark_row_on_key_press_event ((SidebarBookmarkRow*) self, keyval, keycode, state);
#line 176 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 3189 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row_button_release_event_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                             gint n_press,
                                                                             gdouble x,
                                                                             gdouble y,
                                                                             gpointer self)
{
#line 182 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_button_release_event ((SidebarBookmarkRow*) self, n_press, x, y);
#line 3201 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda163_ (SidebarBookmarkRow* self)
{
	GtkImage* _tmp0_;
	GIcon* _tmp1_;
	GIcon* _tmp2_;
#line 185 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->icon;
#line 185 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_sidebar_item_interface_get_gicon ((SidebarSidebarItemInterface*) self);
#line 185 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 185 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_image_set_from_gicon (_tmp0_, _tmp2_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 3218 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda163__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 184 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda163_ ((SidebarBookmarkRow*) self);
#line 3228 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda164_ (SidebarBookmarkRow* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 189 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label;
#line 189 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_bookmark_row_get_display_name (self);
#line 189 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 189 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 3245 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda164__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 188 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda164_ ((SidebarBookmarkRow*) self);
#line 3255 "BookmarkRow.c"
}

static GObject *
sidebar_bookmark_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SidebarBookmarkRow * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GeeHashMap* _tmp8_;
	guint32 _tmp9_;
	guint32 _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GtkLabel* _tmp13_ = NULL;
	GtkStack* _tmp14_ = NULL;
	GtkStack* _tmp15_;
	GtkLabel* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GtkStack* _tmp24_;
	GIcon* _tmp25_;
	GIcon* _tmp26_;
	GtkImage* _tmp27_;
	GtkGrid* _tmp28_ = NULL;
	GtkGrid* _tmp29_;
	GtkImage* _tmp30_;
	GtkGrid* _tmp31_;
	GtkStack* _tmp32_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp33_ = NULL;
	GtkEventBox* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkGrid* _tmp37_;
	GtkEventBox* _tmp38_;
	GtkGrid* _tmp39_;
	GtkEventControllerKey* _tmp40_ = NULL;
	GtkEventControllerKey* _tmp41_;
	GtkGestureMultiPress* _tmp42_ = NULL;
	GtkGestureMultiPress* _tmp43_;
#line 110 "../src/View/Sidebar/BookmarkRow.vala"
	parent_class = G_OBJECT_CLASS (sidebar_bookmark_row_parent_class);
#line 110 "../src/View/Sidebar/BookmarkRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 110 "../src/View/Sidebar/BookmarkRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 111 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 111 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 111 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = files_file_get_by_uri (_tmp1_);
#line 111 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->target_file);
#line 111 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->target_file = _tmp2_;
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = self->priv->target_file;
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	files_file_ensure_query_info (_tmp3_);
#line 117 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 117 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 117 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = files_file_utils_sanitize_path (_tmp5_, NULL, FALSE);
#line 117 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = _tmp6_;
#line 117 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp7_);
#line 117 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp7_);
#line 119 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, TRUE);
#line 120 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_id ((SidebarSidebarItemInterface*) self, sidebar_sidebar_item_interface_get_next_item_id ());
#line 121 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_lock (&sidebar_sidebar_item_interface_item_map_lock);
#line 122 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = sidebar_sidebar_item_interface_item_id_map;
#line 122 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 122 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = _tmp9_;
#line 122 "../src/View/Sidebar/BookmarkRow.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, (gpointer) ((guintptr) _tmp10_), (SidebarSidebarItemInterface*) self);
#line 123 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_unlock (&sidebar_sidebar_item_interface_item_map_lock);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = sidebar_bookmark_row_get_display_name (self);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = _tmp11_;
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_label_set_xalign (_tmp13_, 0.0f);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_START);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_label_set_ellipsize (_tmp13_, PANGO_ELLIPSIZE_END);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp13_);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	self->label = _tmp13_;
#line 132 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp14_ = (GtkStack*) gtk_stack_new ();
#line 132 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_homogeneous (_tmp14_, FALSE);
#line 132 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp14_);
#line 132 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label_stack);
#line 132 "../src/View/Sidebar/BookmarkRow.vala"
	self->label_stack = _tmp14_;
#line 135 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp15_ = self->label_stack;
#line 135 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp16_ = self->label;
#line 135 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_add_named (_tmp15_, (GtkWidget*) _tmp16_, "label");
#line 137 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp17_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 137 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp18_ = _tmp17_;
#line 137 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp18_) {
#line 3396 "BookmarkRow.c"
		GtkEntry* _tmp19_;
		GtkStack* _tmp20_;
		GtkEntry* _tmp21_;
		GtkEntry* _tmp22_;
		GtkEntry* _tmp23_;
#line 138 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp19_ = (GtkEntry*) gtk_entry_new ();
#line 138 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_ref_sink (_tmp19_);
#line 138 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->editable);
#line 138 "../src/View/Sidebar/BookmarkRow.vala"
		self->editable = _tmp19_;
#line 139 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp20_ = self->label_stack;
#line 139 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp21_ = self->editable;
#line 139 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_stack_add_named (_tmp20_, (GtkWidget*) _tmp21_, "editable");
#line 140 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp22_ = self->editable;
#line 140 "../src/View/Sidebar/BookmarkRow.vala"
		g_signal_connect_object (_tmp22_, "activate", (GCallback) __sidebar_bookmark_row____lambda161__gtk_entry_activate, self, 0);
#line 148 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp23_ = self->editable;
#line 148 "../src/View/Sidebar/BookmarkRow.vala"
		g_signal_connect_object ((GtkWidget*) _tmp23_, "focus-out-event", (GCallback) __sidebar_bookmark_row____lambda162__gtk_widget_focus_out_event, self, 0);
#line 3424 "BookmarkRow.c"
	}
#line 152 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp24_ = self->label_stack;
#line 152 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp24_, "label");
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp25_ = sidebar_sidebar_item_interface_get_gicon ((SidebarSidebarItemInterface*) self);
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp26_ = _tmp25_;
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp27_ = (GtkImage*) gtk_image_new_from_gicon (_tmp26_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp27_);
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->icon);
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->icon = _tmp27_;
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp28_ = (GtkGrid*) gtk_grid_new ();
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_set_column_spacing (_tmp28_, 6);
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp28_);
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->icon_label_grid);
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	self->icon_label_grid = _tmp28_;
#line 159 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp29_ = self->icon_label_grid;
#line 159 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp30_ = self->priv->icon;
#line 159 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 0, 0, 1, 2);
#line 160 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp31_ = self->icon_label_grid;
#line 160 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp32_ = self->label_stack;
#line 160 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
#line 162 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp33_ = (GtkEventBox*) gtk_event_box_new ();
#line 162 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_event_box_set_above_child (_tmp33_, FALSE);
#line 162 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp33_);
#line 162 "../src/View/Sidebar/BookmarkRow.vala"
	event_box = _tmp33_;
#line 165 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp34_ = event_box;
#line 165 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp35_ = self->icon_label_grid;
#line 165 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 167 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp36_ = (GtkGrid*) gtk_grid_new ();
#line 167 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp36_);
#line 167 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->content_grid);
#line 167 "../src/View/Sidebar/BookmarkRow.vala"
	self->content_grid = _tmp36_;
#line 168 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp37_ = self->content_grid;
#line 168 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp38_ = event_box;
#line 168 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 0, 0, 1, 1);
#line 170 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp39_ = self->content_grid;
#line 170 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp39_);
#line 171 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 173 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp40_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 173 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp40_, GTK_PHASE_BUBBLE);
#line 173 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 173 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->key_controller = _tmp40_;
#line 176 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp41_ = self->priv->key_controller;
#line 176 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp41_, "key-pressed", (GCallback) _sidebar_bookmark_row_on_key_press_event_gtk_event_controller_key_key_pressed, self, 0);
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp42_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp42_, GTK_PHASE_BUBBLE);
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp42_, (guint) 0);
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->button_controller = _tmp42_;
#line 182 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp43_ = self->priv->button_controller;
#line 182 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp43_, "released", (GCallback) _sidebar_bookmark_row_button_release_event_gtk_gesture_multi_press_released, self, 0);
#line 184 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GObject*) self, "notify::gicon", (GCallback) __sidebar_bookmark_row___lambda163__g_object_notify, self, 0);
#line 188 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GObject*) self, "notify::custom-name", (GCallback) __sidebar_bookmark_row___lambda164__g_object_notify, self, 0);
#line 192 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_set_up_drag (self);
#line 193 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_set_up_drop (self);
#line 110 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (event_box);
#line 110 "../src/View/Sidebar/BookmarkRow.vala"
	return obj;
#line 3536 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_class_init (SidebarBookmarkRowClass * klass,
                                 gpointer klass_data)
{
	GtkTargetEntry _tmp0_ = {0};
	GtkTargetEntry* _tmp1_;
	GtkTargetEntry _tmp2_ = {0};
	GtkTargetEntry _tmp3_ = {0};
	GtkTargetEntry* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GRand* _tmp7_;
	GRand* _tmp8_;
	GeeHashMap* _tmp9_;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_type_class_adjust_private_offset (klass, &SidebarBookmarkRow_private_offset);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	((SidebarBookmarkRowClass *) klass)->on_key_press_event = (gboolean (*) (SidebarBookmarkRow*, guint, guint, GdkModifierType)) sidebar_bookmark_row_real_on_key_press_event;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	((SidebarBookmarkRowClass *) klass)->button_release_event = (void (*) (SidebarBookmarkRow*, gint, gdouble, gdouble)) sidebar_bookmark_row_real_button_release_event;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	((SidebarBookmarkRowClass *) klass)->popup_context_menu = (void (*) (SidebarBookmarkRow*)) sidebar_bookmark_row_real_popup_context_menu;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sidebar_bookmark_row_get_property;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sidebar_bookmark_row_set_property;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->constructor = sidebar_bookmark_row_constructor;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->finalize = sidebar_bookmark_row_finalize;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY] = g_param_spec_string ("custom-name", "custom-name", "custom-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY] = g_param_spec_object ("list", "list", "list", SIDEBAR_TYPE_SIDEBAR_LIST_INTERFACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_ID_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_URI_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY] = g_param_spec_boolean ("permanent", "permanent", "permanent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY] = g_param_spec_boolean ("can-insert-before", "can-insert-before", "can-insert-before", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY] = g_param_spec_boolean ("can-insert-after", "can-insert-after", "can-insert-after", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY] = g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY] = g_param_spec_object ("action-group", "action-group", "action-group", g_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY] = g_param_spec_string ("action-group-namespace", "action-group-namespace", "action-group-namespace", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	memset (&_tmp0_, 0, sizeof (GtkTargetEntry));
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_.target = "text/plain";
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_.flags = (guint) GTK_TARGET_SAME_APP;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_.info = (guint) FILES_TARGET_TYPE_BOOKMARK_ROW;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = g_new0 (GtkTargetEntry, 1);
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_[0] = _tmp0_;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_source_targets = _tmp1_;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_source_targets_length1 = 1;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row_source_targets_size_ = sidebar_bookmark_row_source_targets_length1;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	memset (&_tmp2_, 0, sizeof (GtkTargetEntry));
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_.target = "text/uri-list";
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_.flags = (guint) GTK_TARGET_SAME_APP;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_.info = (guint) FILES_TARGET_TYPE_TEXT_URI_LIST;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	memset (&_tmp3_, 0, sizeof (GtkTargetEntry));
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_.target = "text/plain";
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_.flags = (guint) GTK_TARGET_SAME_APP;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_.info = (guint) FILES_TARGET_TYPE_BOOKMARK_ROW;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = g_new0 (GtkTargetEntry, 2);
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_[0] = _tmp2_;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_[1] = _tmp3_;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_dest_targets = _tmp4_;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_dest_targets_length1 = 2;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row_dest_targets_size_ = sidebar_bookmark_row_dest_targets_length1;
#line 40 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_text_data_atom = gdk_atom_intern_static_string ("text/plain");
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, g_get_real_time ());
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = _tmp5_;
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = g_rand_new_with_seed ((guint32) atoi (_tmp6_));
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = _tmp7_;
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_row_id = g_rand_int (_tmp8_);
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_g_rand_free0 (_tmp8_);
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp6_);
#line 48 "../src/View/Sidebar/BookmarkRow.vala"
	_vala_clear_GMutex (&sidebar_sidebar_item_interface_item_map_lock);
#line 48 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_init (&sidebar_sidebar_item_interface_item_map_lock);
#line 49 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 49 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (sidebar_sidebar_item_interface_item_id_map);
#line 49 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_item_id_map = _tmp9_;
#line 3669 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_sidebar_sidebar_item_interface_interface_init (SidebarSidebarItemInterfaceIface * iface,
                                                                    gpointer iface_data)
{
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_sidebar_sidebar_item_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->update_plugin_data = (void (*) (SidebarSidebarItemInterface*, FilesSidebarPluginItem*)) sidebar_bookmark_row_real_update_plugin_data;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->destroy_bookmark = (void (*) (SidebarSidebarItemInterface*)) sidebar_bookmark_row_real_destroy_bookmark;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->add_extra_menu_items = (void (*) (SidebarSidebarItemInterface*, PopupMenuBuilder*)) sidebar_bookmark_row_real_add_extra_menu_items;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_index = (gint (*) (SidebarSidebarItemInterface*)) gtk_list_box_row_get_index;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_custom_name = sidebar_bookmark_row_real_get_custom_name;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_custom_name = sidebar_bookmark_row_real_set_custom_name;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_list = sidebar_bookmark_row_real_get_list;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_list = sidebar_bookmark_row_real_set_list;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_id = sidebar_bookmark_row_real_get_id;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_id = sidebar_bookmark_row_real_set_id;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_uri = sidebar_bookmark_row_real_get_uri;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_uri = sidebar_bookmark_row_real_set_uri;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_gicon = sidebar_bookmark_row_real_get_gicon;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_gicon = sidebar_bookmark_row_real_set_gicon;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_pinned = sidebar_bookmark_row_real_get_pinned;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_pinned = sidebar_bookmark_row_real_set_pinned;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_permanent = sidebar_bookmark_row_real_get_permanent;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_permanent = sidebar_bookmark_row_real_set_permanent;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_can_insert_before = sidebar_bookmark_row_real_get_can_insert_before;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_can_insert_before = sidebar_bookmark_row_real_set_can_insert_before;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_can_insert_after = sidebar_bookmark_row_real_get_can_insert_after;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_can_insert_after = sidebar_bookmark_row_real_set_can_insert_after;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_menu_model = sidebar_bookmark_row_real_get_menu_model;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_menu_model = sidebar_bookmark_row_real_set_menu_model;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_action_group = sidebar_bookmark_row_real_get_action_group;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_action_group = sidebar_bookmark_row_real_set_action_group;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_action_group_namespace = sidebar_bookmark_row_real_get_action_group_namespace;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_action_group_namespace = sidebar_bookmark_row_real_set_action_group_namespace;
#line 3734 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_instance_init (SidebarBookmarkRow * self,
                                    gpointer klass)
{
	GdkDragAction _tmp0_;
	GdkDragAction* _tmp1_;
	gchar* _tmp2_;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv = sidebar_bookmark_row_get_instance_private (self);
#line 52 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->valid = TRUE;
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_file_list = NULL;
#line 56 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_text = NULL;
#line 57 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_occurred = FALSE;
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = GDK_ACTION_DEFAULT;
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = __gdk_drag_action_dup0 (&_tmp0_);
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->current_suggested_action = _tmp1_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = g_strdup ("");
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_custom_name = _tmp2_;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_can_insert_before = TRUE;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_can_insert_after = TRUE;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_menu_model = NULL;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_action_group = NULL;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_action_group_namespace = NULL;
#line 3774 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_finalize (GObject * obj)
{
	SidebarBookmarkRow * self;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 53 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->icon);
#line 54 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->target_file);
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	(self->priv->drop_file_list == NULL) ? NULL : (self->priv->drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->drop_file_list), NULL));
#line 56 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->drop_text);
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->current_suggested_action);
#line 59 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 60 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 62 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->content_grid);
#line 63 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->icon_label_grid);
#line 64 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label_stack);
#line 65 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->editable);
#line 66 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label);
#line 67 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->drop_revealer);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->_custom_name);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_list);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->_uri);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_gicon);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_menu_model);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_action_group);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->_action_group_namespace);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (sidebar_bookmark_row_parent_class)->finalize (obj);
#line 3825 "BookmarkRow.c"
}

 G_GNUC_NO_INLINE static GType
sidebar_bookmark_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SidebarBookmarkRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sidebar_bookmark_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SidebarBookmarkRow), 0, (GInstanceInitFunc) sidebar_bookmark_row_instance_init, NULL };
	static const GInterfaceInfo sidebar_sidebar_item_interface_info = { (GInterfaceInitFunc) sidebar_bookmark_row_sidebar_sidebar_item_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType sidebar_bookmark_row_type_id;
	sidebar_bookmark_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "SidebarBookmarkRow", &g_define_type_info, 0);
	g_type_add_interface_static (sidebar_bookmark_row_type_id, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, &sidebar_sidebar_item_interface_info);
	SidebarBookmarkRow_private_offset = g_type_add_instance_private (sidebar_bookmark_row_type_id, sizeof (SidebarBookmarkRowPrivate));
	return sidebar_bookmark_row_type_id;
}

GType
sidebar_bookmark_row_get_type (void)
{
	static volatile gsize sidebar_bookmark_row_type_id__once = 0;
	if (g_once_init_enter (&sidebar_bookmark_row_type_id__once)) {
		GType sidebar_bookmark_row_type_id;
		sidebar_bookmark_row_type_id = sidebar_bookmark_row_get_type_once ();
		g_once_init_leave (&sidebar_bookmark_row_type_id__once, sidebar_bookmark_row_type_id);
	}
	return sidebar_bookmark_row_type_id__once;
}

static void
_vala_sidebar_bookmark_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	SidebarBookmarkRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	switch (property_id) {
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_bookmark_row_get_display_name (self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ID_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_uint (value, sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_URI_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_gicon ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_permanent ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_can_insert_before ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_can_insert_after ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_menu_model ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_action_group ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_sidebar_item_interface_get_action_group_namespace ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 3940 "BookmarkRow.c"
		default:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 3946 "BookmarkRow.c"
	}
}

static void
_vala_sidebar_bookmark_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	SidebarBookmarkRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	switch (property_id) {
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_custom_name ((SidebarSidebarItemInterface*) self, g_value_get_string (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_list ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ID_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_id ((SidebarSidebarItemInterface*) self, g_value_get_uint (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_URI_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_uri ((SidebarSidebarItemInterface*) self, g_value_get_string (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_gicon ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_pinned ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_permanent ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_can_insert_before ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_can_insert_after ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_menu_model ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_action_group ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_action_group_namespace ((SidebarSidebarItemInterface*) self, g_value_get_string (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 4032 "BookmarkRow.c"
		default:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 4038 "BookmarkRow.c"
	}
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

